"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const flexiblepersistence_1 = require("flexiblepersistence");
const backapi_1 = require("backapi");
class BaseControllerDefault extends backapi_1.AbstractControllerDefault {
    constructor() {
        super(...arguments);
        this.restFramework = undefined;
        this.communication = 'socket';
    }
    emit(_requestOrData, responseOrSocket, _headers, operation, status, object) {
        const returnName = this.formatName().charAt(0).toLowerCase() +
            this.formatName().slice(1) +
            (operation === undefined ? '' : '.' + flexiblepersistence_1.Operation[operation]);
        const cache = [];
        const cleanObject = JSON.parse(JSON.stringify(object, (_key, value) => {
            if (typeof value === 'object' && value !== null) {
                // Duplicate reference found, discard key
                if (cache.includes(value))
                    return;
                // Store value in our collection
                cache.push(value);
            }
            return value;
        }));
        return responseOrSocket.emit(returnName, {
            status,
            object: cleanObject,
        });
    }
}
exports.default = BaseControllerDefault;
//# sourceMappingURL=baseControllerDefault.js.map